#! /usr/bin/env python

# TuxumSSH python library 
# License: GPL v2
# Author: Tuxum Secure Systems, S. L.

import os
import os.path
import tempfile
import string

#Default values
SSHORGY="/usr/sbin/ssh_orgy"

# Error definitions
OK=0
NO_ERROR=0
ERROR_UNSPECIFIED=1

class TuxumSSH:
	"""
	TuxumSSH SSH helper library class
	"""

	def __init__(self, thisNodeAddress, otherNodeAddress):
		"""
		TuxumSSH constructor
		"""
		TuxumSSH.localAddress = thisNodeAddress
		TuxumSSH.remoteAddress = otherNodeAddress
		TuxumSSH.localUser = "root"
		TuxumSSH.remoteUser = "root"

	def sshOrgy( self, thisNodeName = None, otherNodeName = None ):
		"""
		Interchanges RSA keys between nodes
		"""
		os.system( "QUIET=1 " + SSHORGY + " " + TuxumSSH.localAddress + " " + TuxumSSH.remoteAddress )
		if ( thisNodeName != None and otherNodeName != None ):
			os.system( "QUIET=1 " + SSHORGY + " " + thisNodeName + " " + otherNodeName )
			

	def sendline( self, command ):
		"""
		Executes a command on a remote server
		"""
		os.system( "ssh " + TuxumSSH.remoteUser + "@" + TuxumSSH.remoteAddress + " " + command)

	def sshGet(self, filename):
		"""
		Returns the contents of a remote file
		"""
		tempFile = tempfile.NamedTemporaryFile('w+b', bufsize=-1, suffix='', prefix='tmp', dir='/tmp')
		os.system( "scp " + TuxumSSH.remoteUser + "@" + TuxumSSH.remoteAddress + ":" + filename + " " + tempFile.name )
		fileContent = tempFile.read()
		tempFile.close
		return fileContent
